export default class CallbackCollection {
  static callbacks = new Set()
  static oldSize = 0

  add (callback) {
    this.callbacks.add(callback)
    this.refresh()
  }

  delete (callback) {
    this.callbacks.delete(callback)
    this.refresh()
  }

  refresh () {
    const { oldSize } = this
    const { size } = this.callbacks

    if (size === oldSize) {
      return
    }

    this.oldSize = size

    if (size === 0) {
      this.stop()

      return
    }

    if (size === 1 && oldSize === 0) {
      this.start()

      return
    }
  }

  run (...args) {
    this.callbacks.forEach((callback) => { callback(...args) })
  }
}
