export default {
  getters: {
    baseQuaternion (state) {
      const { sin, cos } = Math
      const degToRad = Math.PI / 180
      const { alpha, beta, gamma } = state.orientation

      const alphaRad = alpha * degToRad
      const betaRad = beta * degToRad
      const gammaRad = gamma * degToRad

      const sinAlpha = sin(alphaRad / 2)
      const sinBeta = sin(betaRad / 2)
      const sinGamma = sin(gammaRad / 2)
      const cosAlpha = cos(alphaRad / 2)
      const cosBeta = cos(betaRad / 2)
      const cosGamma = cos(gammaRad / 2)

      return [
        (cosBeta * cosGamma * cosAlpha) - (sinBeta * sinGamma * sinAlpha),
        (sinBeta * cosGamma * cosAlpha) - (cosBeta * sinGamma * sinAlpha),
        (cosBeta * sinGamma * cosAlpha) + (sinBeta * cosGamma * sinAlpha),
        (cosBeta * cosGamma * sinAlpha) + (sinBeta * sinGamma * cosAlpha)
      ]
    }
  }
}
